Package serp.bytecode

# Class TableSwitchInstruction

java.lang.Object
serp.bytecode.Instruction
serp.bytecode.JumpInstruction
serp.bytecode.TableSwitchInstruction

All Implemented Interfaces:
  `BCEntity`, `InstructionPtr`, `VisitAcceptor`

public class TableSwitchInstruction extends JumpInstruction
The `tableswitch` instruction.

Author:
  Abe White

## Method Summary

Modifier and Type
Method
Description
`void`
`acceptVisit(BCVisitor visit)`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.
`TableSwitchInstruction`
`addTarget(Instruction target)`
Add a target to this switch.
`int`
`getDefaultOffset()`
Synonymous with `JumpInstruction.getOffset()`.
`Instruction`
`getDefaultTarget()`
Synonymous with `JumpInstruction.getTarget()`.
`int`
`getHigh()`
`int`
`getLow()`
`int[]`
`getOffsets()`
Returns the current byte offsets for the different switch cases in this Instruction.
`int`
`getStackChange()`
Return the number of stack positions this instruction pushes or pops during its execution.
`Instruction[]`
`getTargets()`
Return the targets for this switch, or empty array if not set.
`void`
`replaceTarget(Instruction oldTarget, Instruction newTarget)`
Replace the given old, likely invalid, target with a new target.
`TableSwitchInstruction`
`setDefaultOffset(int offset)`
Synonymous with `JumpInstruction.setOffset(int)`.
`TableSwitchInstruction`
`setDefaultTarget(Instruction ins)`
Synonymous with `JumpInstruction.setTarget(serp.bytecode.Instruction)`.
`TableSwitchInstruction`
`setHigh(int high)`
`TableSwitchInstruction`
`setLow(int low)`
`void`
`setOffsets(int[] offsets)`
Sets the offsets for the instructions representing the different switch statement cases.
`TableSwitchInstruction`
`setTargets(Instruction[] targets)`
Set the jump points for this switch.
`void`
`updateTargets()`
Use the byte indexes read from the class file to calculate and set references to the target instruction(s) for this ptr.

### Methods inherited from class serp.bytecode.JumpInstruction

`equalsInstruction, getOffset, getTarget, setOffset, setTarget`

### Methods inherited from class serp.bytecode.Instruction

`getByteIndex, getClassLoader, getCode, getLineNumber, getLogicalStackChange, getName, getOpcode, getPool, getProject, isValid`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface serp.bytecode.InstructionPtr

`getCode`

## Method Details

### getOffsets

public int[] getOffsets()
Returns the current byte offsets for the different switch cases in this Instruction.

### setOffsets

public void setOffsets(int[] offsets)
Sets the offsets for the instructions representing the different switch statement cases. WARNING: these offsets will not be changed in the event that the code is modified following this call. It is typically a good idea to follow this call with a call to updateTargets as soon as the instructions at the given offsets are valid, at which point the Instructions themselves will be used as the targets and the offsets will be updated as expected.

### getDefaultTarget

public Instruction getDefaultTarget()
Synonymous with `JumpInstruction.getTarget()`.

### setDefaultTarget

public TableSwitchInstruction setDefaultTarget(Instruction ins)
Synonymous with `JumpInstruction.setTarget(serp.bytecode.Instruction)`.

### getDefaultOffset

public int getDefaultOffset()
Synonymous with `JumpInstruction.getOffset()`.

### setDefaultOffset

public TableSwitchInstruction setDefaultOffset(int offset)
Synonymous with `JumpInstruction.setOffset(int)`.

### getLow

public int getLow()

### setLow

public TableSwitchInstruction setLow(int low)

### getHigh

public int getHigh()

### setHigh

public TableSwitchInstruction setHigh(int high)

### getTargets

public Instruction[] getTargets()
Return the targets for this switch, or empty array if not set.

### setTargets

public TableSwitchInstruction setTargets(Instruction[] targets)
Set the jump points for this switch.

Returns:
  this instruction, for method chaining

### addTarget

public TableSwitchInstruction addTarget(Instruction target)
Add a target to this switch.

Returns:
  this instruction, for method chaining

### getStackChange

public int getStackChange()
Description copied from class: `Instruction`
Return the number of stack positions this instruction pushes or pops during its execution.

Overrides:
  `getStackChange` in class `Instruction`
Returns:
  0 if the stack is not affected by this instruction, a positive number if it pushes onto the stack, and a negative number if it pops from the stack

### updateTargets

public void updateTargets()
Description copied from interface: `InstructionPtr`
Use the byte indexes read from the class file to calculate and set references to the target instruction(s) for this ptr. This method will be called after the byte code has been read in for the first time and before it is written after modification.

Specified by:
  `updateTargets` in interface `InstructionPtr`
Overrides:
  `updateTargets` in class `JumpInstruction`

### replaceTarget

public void replaceTarget(Instruction oldTarget, Instruction newTarget)
Description copied from interface: `InstructionPtr`
Replace the given old, likely invalid, target with a new target. The new target Instruction is guaranteed to be in the same code block as this InstructionPtr.

Specified by:
  `replaceTarget` in interface `InstructionPtr`
Overrides:
  `replaceTarget` in class `JumpInstruction`

### acceptVisit

public void acceptVisit(BCVisitor visit)
Description copied from interface: `VisitAcceptor`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.

Specified by:
  `acceptVisit` in interface `VisitAcceptor`
Overrides:
  `acceptVisit` in class `JumpInstruction`